﻿// charset="UTF-8"

//===============================================================================
// AjaxComboBox 1.2 
// Copyright (C) 2011 Cosdac Co. Ltd.
// http://cosdac.co.jp/
//
// license : MIT License (http://www.opensource.org/licenses/mit-license.php)
//===============================================================================

function AjaxComboBox(option)
{

	//オブジェクト
	this._inputObj = document.getElementById(option.inputID);
	this._listObj = document.getElementById(option.listID);
	this._listChildObj = document.getElementById(option.listID).childNodes;
	this._setObj = document.getElementById(option.setID);

	//ajaxによる通信の制御
	this._ajax_url = option.URL;
	this._ajax_getpara = option.URL_Querystring;
	this._inputObj_length = option.ExecuteInputLength;

	//スクロールバーおよびリスト制御
	this._list_scroll = option.isScrollbar;
	this._list_height = option.listHeight;
	this._list_width =  option.listWidth;

	//内部変数
	this._timeID = null;
	this._interval = 200;
	this._closeinterval = 10;
	this._count = 0;
	this._listSlectPosition = -1;
	this._wkpoint = new function() { this.x = 0; this.y = 0; };

	this._init();
}

AjaxComboBox.prototype = {
	_init : function()
	{
		var _this = this;

		//イベントハンドラをセット
		//IE以外のためにobject.eventを「e」に渡す。
		this._inputObj.onkeyup=function (e){_this._dataKeyUp(e);};
		this._inputObj.onkeypress=function (e){return _this._dataKeyPress(e);};

		this._inputObj.onblur=function (){_this._timeID = setTimeout(function () { _this._closeList(); }, _this._closeinterval);};
		this._listObj.onfocus=function (){clearTimeout(_this._timeID);_this._timeID=null;setTimeout(function () { _this._inputObj.focus();},10);};

		this._listObj.style.border="#5a799d 1px solid";
		this._listObj.style.position="absolute";
		this._listObj.style.display="none";
		this._listObj.style.overflow="hidden";
		this._listObj.style.backgroundColor="white";
	},
	_dataKeyUp : function(e)
	{
		
		var _this = this;

		if (this._timeID != null){
			clearTimeout(this._timeID);
			this._timeID=null;
		}

		if(window.event){
			e=window.event;
		}

		if(this._inputObj.value.length < this._inputObj_length){
			this._closeList();
			return false;

		} else if(e.keyCode==13){

			if(this._listSlectPosition == -1){
				this._closeList();
				return false;
			}

		} else if(e.keyCode==40){

			var po = this._listChildObj.length; 
	
			if (this._listObj.style.display=='none'){
				this._timeID = setTimeout(function () { _this._getList(); } , _this._interval);
			}else{
	
				for (i= this._listSlectPosition+1; i<po; i++)
				{
					var obj_item =  this._listChildObj.item(i);
					if (obj_item.id.substring(0,3)=='val') {
						 this._setListSelection(obj_item, i);
						 this._setListscroll(obj_item);
						break;
					}
				}
			}
			return false;

		}else if(e.keyCode==38){

			for (i=this._listSlectPosition-1; i>=-1; i--)
			{
				if (i<=-1) {
					this._setListSelection(null, -1);
					this._setListscroll(null);
					break;
				}
				var obj_item = this._listChildObj.item(i);
				if (obj_item.id.substring(0,3)=='val') {
					this._setListSelection(obj_item , i);
					this._setListscroll(obj_item);
					break;
				}
			}
			return false;
		}

		this._timeID = setTimeout(function () { _this._getList(); },_this._interval);

		return true;
	},
	_dataKeyPress : function(e)
	{
		
		if(window.event){
			e=window.event;
		}

		if(e.keyCode==13){
			if(this._listSlectPosition == -1){
				this._closeList();
				e.returnValue=true;
				return true;
			}else{
				this._setListValue(this._listChildObj.item(this._listSlectPosition));
				this._closeList();
				e.returnValue=false;
				e.cancelBubble=true;
				return false;
			}
		}
		e.returnValue=true;
		return true;
	},
	_getList : function()
	{
		
		this._count++;
		var pageURL = this._ajax_url + '?' + this._ajax_getpara + '=' + encodeURI(this._inputObj.value);
	
		xmlhttp = this._createXMLHttp();
		if (xmlhttp)
		{
			var _this = this;
			xmlhttp.onreadystatechange = function() {_this._setData(_this);};
			xmlhttp.open('GET', pageURL);
			xmlhttp.send(null);
		}else{
			alert("XMLHttpRequests");
		}
	},
	_setData : function(_this)
	{

		if (xmlhttp.readyState == 4 && xmlhttp.status == 200)
		{
			var objXML = xmlhttp.responseXML;
	
		        if ( objXML.documentElement )
			{
				var obj_items = objXML.documentElement.getElementsByTagName('item');
				if (obj_items.length != 0) 
				{

					while (_this._listObj.firstChild) {
					  _this._listObj.removeChild(_this._listObj.firstChild);
					}

					var boderflg = false;
					for (i=0; i<obj_items.length; i++)
					{
	
						var obj_item = obj_items[i].getElementsByTagName('msg');
					        if ( obj_item.length != 0 ) {
							var msg = obj_item[0].firstChild.data;

							var msgDiv = document.createElement('div');
							msgDiv.id = 'msg' + i ;
							msgDiv.name = 'msg' + i ;
							if (i!=0&&boderflg==false) msgDiv.style.borderTop = "solid 1px #000000";
							msgDiv.style.borderBottom = "solid 1px #000000";
							msgDiv.style.color = "green";
							msgDiv.style.textAlign = "left";
							msgDiv.style.padding = "3px 4px 1px 3px";
							msgDiv.innerHTML  = msg;
							_this._listObj.appendChild(msgDiv);

							boderflg=true;
						}
	
						var obj_item = obj_items[i].getElementsByTagName('val');
					        if ( obj_item.length != 0 ) {
							var val = obj_item[0].firstChild.data;

							var valDiv = document.createElement('div');
							valDiv.id = 'val' + i ;
							valDiv.name = 'val' + i ;
							valDiv.style.textAlign = "left";
							valDiv.style.padding = "2px 4px 2px 3px";
							valDiv.innerHTML  = val ;

							//以下のようにイベントを追加したいところだがクロージャによって”(valDiv) or (valDiv , i)”が
							//各行の値を示さないので注意
							//_this._addEvent(valDiv,"mousedown",function () {_this._setListValue(valDiv);})
							//_this._addEvent(valDiv,"mouseover",function () {_this._setListSelection(valDiv , i);})

							var event_mousedown = function(obj) {
												_this._addEvent(obj,"mousedown",function () {_this._setListValue(obj);})
							};
							var event_mouseover = function(obj , n) {
												_this._addEvent(obj,"mouseover",function () {_this._setListSelection(obj , n);})
							};

							event_mousedown(valDiv);
							event_mouseover(valDiv , i);

							_this._listObj.appendChild(valDiv);

							boderflg=false;
						}
	
					}
	
					_this._showList();
	
				}else{
					_this._closeList();
				}
			}else{
				_this._closeList();
			}
		}
	},
	_createXMLHttp : function()
	{
		try {
			return new ActiveXObject ("Microsoft.XMLHTTP");
		}catch(e){
			try {
				return new XMLHttpRequest();
			}catch(e) {
				return null;
			}
		}
		return null;
	},
	_showList : function()
	{
	
		
		this._listSlectPosition =-1;
	
		this._setListscroll(null);
	
		var po = this._getListPoint(this._inputObj);
	
		this._listObj.style.top=(po.y + this._inputObj.offsetHeight)+'px';
		this._listObj.style.left=(po.x)+'px';
	
		if (this._list_scroll) {
			this._listObj.style.overflow="auto";
		}
	
		this._listObj.style.height = 'auto';
		this._listObj.style.display='block';
		var list_child_height = this._listObj.offsetHeight;
		var list_child_width  = this._listObj.offsetWidth;
	
		var parseList_height = parseFloat(this._list_height);
		if (isNaN(parseList_height)==false ) {
			if (parseList_height < list_child_height ) {
				this._listObj.style.height = (parseList_height)+'px';
			}
		}
	
		var parseList_width = parseFloat(this._list_width);
		if (isNaN(parseList_width)==false) {
			this._listObj.style.width = (parseList_width)+'px';
		}else{
			this._listObj.style.width = (this._inputObj.offsetWidth -2)+'px';
		}
	
		//SELECT要素やActiveXコントロールなどのz-index対策
		this._listObj.style.zIndex = 100;
	
		var shim = document.getElementById("__shim"+ this._listObj.id);
		if (shim==null) {
	
			shim = document.createElement("iframe"); 
	
			shim.setAttribute('frameborder',0); 
			shim.setAttribute('scrolling','no');
	
			shim.style.width = '0px';
			shim.style.height = '0px';
			shim.style.top = '0px';
			shim.style.left = '0px';
	
			shim.name = "__shim"+ this._listObj.id;
			shim.id   = "__shim"+ this._listObj.id;
			shim.style.position = "absolute";
			shim.style.zIndex = this._listObj.style.zIndex - 1;
	
			document.body.appendChild(shim);
	
		}
	
		shim.style.width = (this._listObj.offsetWidth)+'px';
		shim.style.height = (this._listObj.offsetHeight)+'px';
		shim.style.top = (this._listObj.style.top);
		shim.style.left = (this._listObj.style.left);
	
		shim.style.display = "block";
	
		var _this = this;
		setTimeout(function () { _this._inputObj.focus();} ,10);
	},
	_getListPoint : function(obj)
	{
		
		// document.allでは、例えばtable要素内のオブジェクトの座標を取得するのだとすると、
		// tableのleft、topを(0,0)とした座標を取得するので、入れ子を考慮してループさせている
		this._wkpoint.x=0;
		this._wkpoint.y=0;

		while(obj){
			this._wkpoint.x += obj.offsetLeft;
			this._wkpoint.y += obj.offsetTop;
			obj = obj.offsetParent;
		} 

		return this._wkpoint;
	},
	_closeList : function()
	{
		
		this._setListscroll(null);
		this._listSlectPosition=-1;
		this._listObj.style.display='none';
	
		var shim = document.getElementById("__shim"+ this._listObj.id);
		if (shim!=null) {
			shim.style.display = "none";
		}
	
	},
	_setListSelection : function(obj, pos)
	{
		
		if (this._listSlectPosition >=0){
			this._setListColor(this._listObj.childNodes.item(this._listSlectPosition),false);
		}
	
		if (obj!=null){
			this._setListColor(obj,true);
		} else {
			pos = -1
		}
	
		this._listSlectPosition = Number(pos);
	
	},
	_setListscroll : function(obj)
	{
		
		if (obj!=null){
			var pos = obj.offsetTop + obj.offsetHeight - this._listObj.clientHeight;
	
			if (pos >=  this._listObj.scrollTop) {
				 this._listObj.scrollTop = pos;
	
			}else if (pos +  this._listObj.clientHeight <=  this._listObj.scrollTop) {
				 this._listObj.scrollTop = obj.offsetTop;
			}
		}else{
			 this._listObj.scrollTop = 0;
		}
	},
	_setListColor : function(obj,col)
	{
		if(col){
			obj.style.backgroundColor = '#3366cc';
			obj.style.color = '#FFFFFF';
		}else{
			obj.style.backgroundColor = '#FFFFFF';
			obj.style.color = '';
		}
	},
	_setListValue : function(obj)
	{
		
		this._setObj.value=obj.innerHTML;
		this._closeList();

		var _this = this;
		setTimeout(function () {_this._setObj.focus();},10);
	},
	_addEvent : function(elm, type, event){
		if(elm.addEventListener) {
			elm.addEventListener(type, event, false); 
		} else if(elm.attachEvent) {
			elm.attachEvent('on'+type, event); 
		} else {
			elm['on'+type] = event;
		}
	}
}